## biosig4c++ 1.3.0

=== Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  $Id$
###  Copyright (C) 2006,2007,2008,2009,2010,2011,2012 Alois Schloegl <alois.schloegl@ist.ac.at>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################

##### Target: GNU/Linux

## make save2gdf   - makes converter
## make mex4o      - makes mexSLOAD, mexSOPEN for Octave (requires Octave-headers)
## make mex4m      - makes mexSLOAD, mexSOPEN for Matlab (requires Matlab, mex -setup must be configured)
## make mexw32     - makes mexSLOAD.mexw32, mexSOPEN.mexw32 (requires that mingw32, gnumex libraries from Matlab/Win32)
## make mexw64     - makes mexSLOAD.mexw64, mexSOPEN.mexw64 (requires that mce-w32, gnumex libraries from Matlab/Win64)
## make mex        - mex4o and mex4m combined
## make libbiosig  - makes libbiosig
## make biosig4python - makes python interface (requires Python)
## make biosig4java - makes Java interface (experimental)
## make biosig4php - makes PHP interface (experimental)
## make biosig4perl - makes perl interface (experimental)
## make biosig4ruby - makes ruby interface (experimental)
## make biosig4tcl - makes tcl/tk interface (experimental)
## make win32      - makes save2gdf.exe, libbiosig.a, libbiosig.dll, for MSWindows, requires MinGW
## make win64      - makes save2gdf.exe, libbiosig.a, libbiosig.dll for 64bit Windows, requires mce-w64 
## make sigviewer  - makes sigviewer

##### Target: Win32
## make win32      - makes save2gdf.exe,libbiosig.lib,libbiosig.dll, for MSWindows, requires MinGW
## make mexw32 mex/mexSLOAD.mexw32   - requires MinGW32 and GNUMEX libraries from Matlab/Win32
## make win32/sigviewer.exe 	- requires sources of SigViewer, and MinGW32 (mex: make suitesparse zlib qt )

##### Target: Win64
## make win64      - makes save2gdf.exe,libbiosig.lib,libbiosig.dll, for MSWindows, requires MinGW
## make mexw64 mex/mexSLOAD.mexw64   - requires MCE-W64 and GNUMEX libraries from Matlab/Win64
## make win64/sigviewer.exe 	- requires sources of SigViewer and MCE-W64, make suitesparse zlib qt 

###############################
# whether dynamic or static linking is used, can be controlled with
# LIBEXT. Setting it to 'a' links statically, 'so' links dynamically
#
LIBEXT        = a
#LIBEXT	      = so
###############################

### User-specified options: its likely you want to change this
# settings for cross compiler: tested with MXE and mce-w64 with make suitesparse zlib qt ; 
CROSS   = $HOME/src/mxe/usr/bin/i686-pc-mingw32
## local MXE
ifeq "$(wildcard $(CROSS)-gcc)" ""
CROSS         = $(shell pwd)/../mxe/usr/bin/i686-pc-mingw32
endif
ifeq "$(wildcard $(CROSS)-gcc)" ""
CROSS         = /usr/local/src/mxe/usr/bin/i686-pc-mingw32
endif
CROSS64       = $(HOME)/src/mce-w64/usr/bin/x86_64-w64-mingw32
ifeq "$(wildcard $(CROSS64)-gcc)" ""
CROSS64       = $(shell pwd)/../mce-w64/usr/bin/i686-pc-mingw32
endif
ifeq "$(wildcard $(CROSS64)-gcc)" ""
CROSS64       = /usr/local/src/mce-w64/usr/bin/i686-pc-mingw32
endif
# settings for mex files
MEX_OPTION    = -largeArrayDims # turn on for 64 bit Matlab, otherwise empty
# directory for sources of sigviewer
PathToSigViewer = ../sigviewer
PathToSigViewerWIN32 = ../sigviewer4win32
PathToSigViewerWIN64 = ../sigviewer4win64

## default options
CC            = gcc
CXX           = g++
#DEFINES      = -D=WITHOUT_SCP_DECODE
DEFINES       = -D=WITH_ZLIB 
#DEFINES      += -D=WITH_CURL
DEFINES      += -D=__4HAERTEL__
DEFINES      += -D=WITH_FAMOS
DEFINES      += -D=WITH_CHOLMOD
DEFINES      += -D=WITHOUT_NETWORK
#DEFINES      += -D=WITH_HDF
#DEFINES      += -D=WITH_MATIO
#DEFINES      += -D=WITH_LIBXML2 
#DEFINES      += -D=WITH_FEF 
#DEFINES      += -D=WITH_PDP
#DEFINES      += -D=WITH_DICOM
#DEFINES      += -D=WITH_GDCM
#DEFINES      += -D=WITH_GSL
#DEFINES      += -D=WITH_EEPROBE		
#DEFINES      += -D=SOFTCODED_PHYSDIMTABLE	# obsolete
#DEFINES      += -D=CNT32			# for 32bit Neuroscan format
CFLAGS        = -pipe -fPIC -Wall -fno-builtin-memcmp -O2 $(DEFINES) -Wextra # -I cntopenlib/include/
CXXFLAGS      = -pipe -fPIC -Wall -fno-builtin-memcmp -O2 $(DEFINES) -Wextra # -I cntopenlib/include/
AR            = ar crs
INCPATH       = -I /usr/include/libxml2/ -I/opt/local/include/
#INCPATH       = -I /usr/local/include/gdcm-2.0/
#		../gdcm-2.0.10/Source/DataStructureAndEncodingDefinition \
#		../gdcm-2.0.10/Source/InformationObjectDefinition  	\
#		../gdcm-2.0.10/Source/MediaStorageAndFileFormat 	\
#		../gdcm-2.0.10/Source/DataDictionary 			\
#		../gdcm-2.0.10/Source/Common
LINK          = $(CXX)
LFLAGS_dynamic = -L/usr/local/lib/ -L/opt/local/lib -L.
LIBS_dynamic  = -lbiosig
LFLAGS_static = -L/usr/local/lib/ -L/opt/local/lib
LIBS_static   = libbiosig.a
ifeq ($(LIBEXT),so)
  LFLAGS      = $(LFLAGS_dynamic)
  LIBS        = $(LIBS_dynamic)
else
  LFLAGS      = $(LFLAGS_static)
  LIBS        = $(LIBS_static)
endif
ifneq (,$(findstring WITH_ZLIB, $(DEFINES)))
  LDLIBS     += -lz
endif
ifneq (,$(findstring WITH_CHOLMOD, $(DEFINES)))
  LDLIBS     += -lcholmod
endif
ifneq (,$(findstring WITH_LIBXML2, $(DEFINES)))
  LDLIBS     += -lxml2
endif
ifneq (,$(findstring WITH_CURL, $(DEFINES)))
  LDLIBS     += -lcurl
endif
ifneq (,$(findstring WITH_HDF, $(DEFINES)))
  LDLIBS     += -lhdf5
endif
ifneq (,$(findstring WITH_MATIO, $(DEFINES)))
  LDLIBS     += -lmatio
endif
LIBS         += $(LDLIBS)

DELETE        = rm
COPY          = cp -f
DATA_DIR      = data/
TEMP_DIR      = test/

##########################################################
## set Matlab and Octave variables
ifneq ($(shell which matlab), )
  MATLABDIR  := $(dir $(shell readlink -f $(shell which matlab) ) )
  MEX         = $(MATLABDIR)mex
  MEX_EXT    := $(shell $(MATLABDIR)mexext)
endif

# Octave - global install  (e.g. from debian package)
OCTAVE_VERSION = 
# Octave - local install (e.g. compiled from sources) 
#OCTAVE_VERSION = -3.6.1

OCT           := mkoctfile$(OCTAVE_VERSION)
##########################################################

##########################################################
## set variables for Python
SWIG          := swig
PYTHON        := python
PYTHONVER     := $(shell $(PYTHON) -c "import sys; print sys.version[:3]")
PYTHON_INC    := $(shell $(PYTHON) -c 'import numpy.distutils.system_info as si; print " -I".join(si.numpy_info().get_include_dirs())')
NUMPY_INC     := $(shell $(PYTHON) -c 'import numpy.distutils.misc_util as mu; print " -I".join(mu.get_numpy_include_dirs())')

##########################################################
 
##########################################################
## set variables for MinGW Crosscompiler: compile on linux binaries for windows
##
PathToMinGW   = $(dir $(CROSS))..$(nondir $(CROSS))
PathToMinGW64 = $(dir $(CROSS64))..$(nondir $(CROSS64))

MinGWCC      = $(CROSS)-gcc
MinGWCXX     = $(CROSS)-g++
MinGWDEF     = $(DEFINES) 
MinGWCFLAGS  = -pipe -fPIC  -D_REENTRANT -D=BUILD_DLL $(MinGWDEF) -Iwin32 -I$(PathToMinGW)/include/
MinGWLIBS    = win32/libbiosig.a -L$(PathToMinGW)/lib/ -lws2_32 $(LDLIBS) # static
MinGWLINK    = $(MinGWCXX)

MinGW64CC      = $(CROSS64)-gcc
MinGW64CXX     = $(CROSS64)-g++
MinGW64CFLAGS  = -pipe -fPIC -O2 -D_REENTRANT -D=BUILD_DLL $(MinGWDEF) -Iwin32 -I$(PathToMinGW64)/include/
MinGW64LIBS    = win64/libbiosig.a -L$(PathToMinGW64)/lib/ -lws2_32 $(LDLIBS) # static
MinGW64LINK    = $(MinGW64CXX)
##########################################################

# Versioning
MAJOR_VERSION := $(word 3, $(shell grep '\#define BIOSIG_VERSION_MAJOR' biosig.h))
MINOR_VERSION := $(word 3, $(shell grep '\#define BIOSIG_VERSION_MINOR' biosig.h))
STEPPING      := $(word 3, $(shell grep '\#define BIOSIG_PATCHLEVEL' biosig.h))
TODAY         := $(shell date +%Y%m%d)

####### Output directory

OBJ	      = ./obj
BIN	      = $(DESTDIR)/usr/bin
LIB	      = $(DESTDIR)/usr/lib

####### Files
SOURCES       = biosig.c \
		t210/sopen_scp_read.c \
		t210/sopen_famos_read.c \
		t210/sopen_alpha_read.c \
		t210/scp-decode.cpp \
		t220/sopen_scp_write.c \
		t220/crc4scp.c \
		t230/sopen_hl7aecg.c \
		t240/sopen_fef_read.c \
		test0/sandbox.c \
		xgethostname.c \
		physicalunits.c \
		biosig-network.c \
		save2gdf.c \
		biosig_client.c \
		biosig_server.c

ifeq (,$(findstring WITH_LIBXML2, $(DEFINES)))
  ## TinyXML is used when built without libxml2 	
  SOURCES    +=	XMLParser/tinyxml.cpp \
		XMLParser/tinyxmlparser.cpp \
		XMLParser/tinyxmlerror.cpp \
		XMLParser/tinystr.cpp 
endif

OBJECTS       = \
		crc4scp.o \
		biosig.o \
		sopen_scp_read.o \
		sopen_alpha_read.o \
		sopen_scp_write.o \
		sopen_hl7aecg.o \
		biosig-network.o \
		sandbox.o \
		xgethostname.o

MinGWOBJECTS  = \
		win32/crc4scp.obj \
		win32/biosig.obj \
		win32/getlogin.obj \
		win32/strndup.obj \
		win32/strnlen.obj \
		win32/sopen_scp_read.obj \
		win32/sopen_alpha_read.obj \
		win32/sopen_scp_write.obj \
		win32/sopen_hl7aecg.obj \
		win32/biosig-network.obj \
		win32/sandbox.obj \
		win32/xgethostname.obj

ifneq (,$(findstring WITH_FAMOS, $(DEFINES)))
  OBJECTS      += sopen_famos_read.o
endif
ifneq (,$(findstring WITH_FAMOS, $(MinGWDEF)))
  MinGWOBJECTS += win32/sopen_famos_read.obj
endif

ifneq (,$(findstring WITH_FEF, $(DEFINES)))
  OBJECTS      += sopen_fef_read.o
endif
ifneq (,$(findstring WITH_FEF, $(MinGWDEF)))
  MinGWOBJECTS += win32/sopen_fef_read.obj
endif

ifeq (,$(findstring WITHOUT_SCP_DECODE, $(DEFINES)))
  OBJECTS      += scp-decode.o
endif
ifeq (,$(findstring WITHOUT_SCP_DECODE, $(MinGWDEF)))
  MinGWOBJECTS += win32/scp-decode.obj
endif

ifeq (,$(findstring WITH_LIBXML2, $(DEFINES)))
  ## TinyXML is used when built without libxml2 	
  OBJECTS    += tinyxml.o tinyxmlparser.o tinyxmlerror.o tinystr.o 
endif
ifeq (,$(findstring WITH_LIBXML2, $(DEFINES)))
  ## TinyXML is used when built without libxml2 	
  MinGWOBJECTS += win32/tinyxml.obj win32/tinyxmlparser.obj win32/tinyxmlerror.obj win32/tinystr.obj 
endif


MinGW64OBJECTS  = $(patsubst win32/%.obj, win64/%.obj, $(MinGWOBJECTS))

TARGET = save2gdf libbiosig.a

first: $(TARGET)
all:   $(TARGET) mex4o biosig4python sigviewer win32 win64 win32/sigviewer.exe win64/sigviewer.exe #biosig_client biosig_server mma java tcl perl php ruby #sigviewer 
lib:	libbiosig.a win32/libbiosig.dll win32/libbiosig.a win64/libbiosig.a

#############################################################
#	Compilation: Implicit, default rules
#############################################################

.SUFFIXES: .o .c .cpp .cc .cxx .C

.cpp.o:
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"
.cc.o:
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"
.cxx.o:
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"
.C.o:
	$(CC) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"
.c.o:
	$(CC) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"

%.o: %.c biosig.h biosig-dev.h Makefile
	$(CC) -c $(CFLAGS) $(INCPATH) -o "$@" "$<"
%.o: t210/%.c biosig.h biosig-dev.h
	$(CC) -c $(CFLAGS) $(INCPATH) -o "$@" "$<"
%.o: t220/%.c biosig.h biosig-dev.h
	$(CC) -c $(CFLAGS) $(INCPATH) -o "$@" "$<"
%.o: t230/%.c biosig.h biosig-dev.h
	$(CC) -c $(CFLAGS) $(INCPATH) -o "$@" "$<"
%.o: t240/%.c biosig.h biosig-dev.h
	$(CC) -c $(CFLAGS) -I t240 $(INCPATH) -o "$@" "$<"
%.o: test0/%.c biosig.h biosig-dev.h Makefile
	$(CC) -c $(CFLAGS) $(INCPATH) -o "$@" "$<"
%.o: XMLParser/%.cpp
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"

win32/%.obj: %.c  biosig-dev.h biosig.h Makefile
	$(MinGWCC) -c $(MinGWCFLAGS) $(INCPATH) -o "$@" "$<"
win32/%.obj: t210/%.c  biosig-dev.h biosig.h 
	$(MinGWCC) -c $(MinGWCFLAGS) $(INCPATH) -o "$@" "$<"
win32/%.obj: t220/%.c  biosig-dev.h biosig.h 
	$(MinGWCC) -c $(MinGWCFLAGS) $(INCPATH) -o "$@" "$<"
win32/%.obj: t230/%.c  biosig-dev.h biosig.h 
	$(MinGWCC) -c $(MinGWCFLAGS) $(INCPATH) -o "$@" "$<"
win32/%.obj: t240/%.c biosig-dev.h biosig.h 
	$(MinGWCC) -c $(MinGWCFLAGS) -I t240 $(INCPATH) -o "$@" "$<"
win32/%.obj: test0/%.c  biosig-dev.h biosig.h Makefile
	$(MinGWCC) -c $(MinGWCFLAGS) -I t240 $(INCPATH) -o "$@" "$<"
win32/%.obj: win32/%.c

=== igor/Makefile ===
# Makefile for XOP interface to Igor 
# This is experimental for testing the use of MinGW for XOP's
#
# Copyright 2010 A. Schloegl


# configure your cross-compiler and path to IGOR XOP toolkit 
CROSS      = i586-mingw32msvc-
CROSS      = $(HOME)/src/mingw-cross-env/usr/bin/i686-pc-mingw32-

# define path to XOP toolkit
#IGORDIR    = $(HOME)/.wine/drive_c/Program\ Files/WaveMetrics/XOP\ Toolkit\ 6/IgorXOPs6
IGORDIR     = $(HOME)/.wine/drive_c/Program\ Files/WaveMetrics/XOP\ Toolkit\ 5/IgorXOPs5

##### start of Makefile:  

XOP1	    = $(IGORDIR)/XOP1/XOP1.c
GBDIR	    = $(IGORDIR)/GBLoadWave

INCDIR      = -I$(IGORDIR)/XOPSupport/
INCDIR     += -I$(IGORDIR)/XOP1/
INCDIR     += -I$(IGORDIR)/GBLoadWave/
INCDIR     += -I.

LIBS	   += $(IGORDIR)/XOPSupport/VC6/XOPSupport.lib
LIBS	   += ../win32/libbiosig.a ../win32/zlib/lib/libz.a -lws2_32  
LIBS	   += -lversion -lmsvcrt -lcomdlg32

CC	   = g++
DEFINES	   = -D=WINIGOR -D=_WINDOWS_
 
all:XOP1.xop XOPas.xop GBLoadWave.xop


GBLoadWaveres.o: $(GBDIR)/GBLoadWave.rc  
	$(CROSS)windres $(DEFINES) $(INCDIR) $(GBDIR)/GBLoadWave.rc -o GBLoadWaveres.o
GBLoadWave.o: $(GBDIR)/GBLoadWave.c  
	$(CROSS)$(CC) -shared -c -o GBLoadWave.o $(DEFINES) $(INCDIR) -I./$(GBDIR)/ $(GBDIR)/GBLoadWave.c   
GBLoadWaveDialog.o: $(GBDIR)/GBLoadWaveDialog.c  
	$(CROSS)$(CC) -shared -c -o GBLoadWaveDialog.o $(DEFINES) $(INCDIR) -I./$(GBDIR)/ $(GBDIR)/GBLoadWaveDialog.c   
GBLoadWaveOperation.o: $(GBDIR)/GBLoadWaveOperation.c
	$(CROSS)$(CC) -shared -c -o GBLoadWaveOperation.o $(DEFINES) $(INCDIR) -I./$(GBDIR)/ $(GBDIR)/GBLoadWaveOperation.c   
GBScalingDialog.o: $(GBDIR)/GBScalingDialog.c  
	$(CROSS)$(CC) -shared -c -o GBScalingDialog.o $(DEFINES) $(INCDIR) -I./$(GBDIR)/ $(GBDIR)/GBScalingDialog.c   
GBLoadWaveDialog.o: $(GBDIR)/GBLoadWaveDialog.c  
	$(CROSS)$(CC) -shared -c -o GBLoadWaveDialog.o $(DEFINES) $(INCDIR) -I./$(GBDIR)/ $(GBDIR)/GBLoadWaveDialog.c   
GBLoadWave.xop: GBLoadWave.o GBLoadWaveres.o GBLoadWaveOperation.o GBLoadWaveDialog.o GBScalingDialog.o XOPDialogsWin.o libIgor.a XOPSupport.o XOPFiles.o
	$(CROSS)$(CC) -shared -o GBLoadWave.xop GBLoadWave.o GBLoadWaveOperation.o GBLoadWaveDialog.o GBScalingDialog.o XOPDialogsWin.o GBLoadWaveres.o XOPSupport.o XOPFiles.o $(LIBS) libIgor.a  

	
xopSLOAD.o:xopSLOAD.c
	$(CROSS)$(CC) $(DEFINES) $(INCDIR) xopSLOAD.c -o xopSLOAD.o  -c 
#xopSLOAD.xop:libIgor.a XOPSupport.o 
#	$(CROSS)$(CC) -shared -o xopSLOAD.xop $(DEFINES) $(INCDIR) xopSLOAD.c XOPSupport.o $(LIBS) libIgor.a  
xopSLOAD.xop: xopSLOAD.o libIgor.a XOPSupport.o 
	$(CROSS)$(CC) -shared -o xopSLOAD.xop xopSLOAD.o XOPSupport.o $(LIBS) libIgor.a  

	
libIgor.a: $(IGORDIR)/XOPSupport/IGOR.lib
	$(CROSS)reimp -c --as $(CROSS)as --dlltool $(CROSS)dlltool $(IGORDIR)/XOPSupport/IGOR.lib

XOPDialogsWin.o:$(IGORDIR)/XOPSupport/XOPDialogsWin.c
	$(CROSS)$(CC) $(DEFINES) $(INCDIR) $(IGORDIR)/XOPSupport/XOPDialogsWin.c -o XOPDialogsWin.o -c
XOPSupport.o:$(IGORDIR)/XOPSupport/XOPSupport.c
	$(CROSS)$(CC) $(DEFINES) $(INCDIR) $(IGORDIR)/XOPSupport/XOPSupport.c -o XOPSupport.o -c
XOPFiles.o:$(IGORDIR)/XOPSupport/XOPFiles.c
	$(CROSS)$(CC) $(DEFINES) $(INCDIR) $(IGORDIR)/XOPSupport/XOPFiles.c -o XOPFiles.o -c


## compiling XOP1: this should work
XOP1res.o:$(IGORDIR)/XOP1/XOP1.rc
	$(CROSS)windres $(DEFINES) $(INCDIR) $(IGORDIR)/XOP1/XOP1.rc -o XOP1res.o
XOP1.xop: XOPSupport.o libIgor.a XOP1res.o 
	$(CROSS)$(CC) -shared -o XOP1.xop  $(DEFINES) $(INCDIR) $(XOP1) XOP1res.o XOPSupport.o $(LIBS) libIgor.a 


## testing a modified XOP1
XOPasres.o:XOPas.rc
	$(CROSS)windres $(DEFINES) $(INCDIR) XOPas.rc -o XOPasres.o
XOPas.o:XOPas.c
	$(CROSS)$(CC) $(DEFINES) $(INCDIR) XOPas.c -o XOPas.o -c
XOPas.xop:XOPas.o XOPSupport.o libIgor.a  XOPasres.o
	$(CROSS)$(CC) -shared -o XOPas.xop XOPas.o XOPasres.o XOPSupport.o $(LIBS) libIgor.a 


clean:
	rm *.o *.xop *.exe
distclean:
	rm *.o *.xop *~

=== java/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  $Id: Makefile 2526 2010-08-27 21:46:28Z schloegl $
###  Copyright (C) 2010 Alois Schloegl <a.schloegl@ieee.org>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################

# More information on SWIG-Java interface is available here
# http://www.swig.org/Doc1.3/Java.html

all:
	swig -c++ -java biosig.i
	g++ -fPIC -c biosig_wrap.cxx  -I/usr/lib/gcc/x86_64-linux-gnu/4.4/include/ -I/usr/lib/jvm/java-1.5.0-gcj-4.4/include
	ld -G biosig_wrap.o  -o libbiosig4java.so

clean: 
	-rm *.java
	-rm *.o 
	-rm *.cxx 
	-rm *.so

=== mex/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  $Id$
###  Copyright (C) 2006,2007,2008,2009,2011,2012 Alois Schloegl <alois.schloegl@ist.ac.at>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################


### modify directories according to your needs 
INCOCTAVE = -I /usr/include/octave 
MATLABDIR = /usr/local/MATLAB/R2010b/
# comment the following line if you use MATLAB on 32-bit operating system
MEX_OPTION += -largeArrayDims
# LIBEXT. Setting it to 'a' links statically, 'so' links dynamically
LIBEXT        = a
#LIBEXT	      = so
# 
# include directory for Win32-Matlab include
W32MAT_INC = $(HOME)/bin/win32/Matlab/R2010b/extern/include/
W64MAT_INC = $(HOME)/bin/win64/Matlab/R2010b/extern/include/
# path to GNUMEX libraries, available from here http://sourceforge.net/projects/gnumex/
GNUMEX   = $(HOME)/bin/win32/gnumex
GNUMEX64 = $(HOME)/bin/win64/gnumex
###############################


### User-specified options: its likely you want to change this
MEX_OPTION    = -largeArrayDims # turn on for 64 bit Matlab, otherwise empty
LIBS          = -lbiosig $(LDLIBS)
LFLAGS        = -L..
COPY          = cp

mex: mex4m mex4o 
win32 win mexw32: mexSLOAD.mexw32 mexSOPEN.mexw32 mexSSAVE.mexw32
win64 mexw64: mexSLOAD.mexw64 mexSOPEN.mexw64 mexSSAVE.mexw64
all: mex4m mex4o win32 win64

clean:
	-$(RM) *.o *.obj *.o64 core octave-core *.oct *~ *.mex* 

##########################################################
## set Matlab and Octave variables
ifneq ($(shell which matlab), )
  MATLABDIR  := $(dir $(shell readlink -f $(shell which matlab) ) )
  MEX         = $(MATLABDIR)mex
  MEX_EXT    := $(shell $(MATLABDIR)mexext)
endif

# Octave - global install  (e.g. from debian package)
# - defined as variable by calling function 
# OCTAVE_VERSION 	= 

OCT           	= mkoctfile$(OCTAVE_VERSION)
##########################################################

../libbiosig.$(LIBEXT):
	$(MAKE) -C .. libbiosig.$(LIBEXT)

../win32/libbiosig.a:
	$(MAKE) -C .. win32/libbiosig.a

#############################################################
#	MEX-Interface for Octave and Matlab
#############################################################
mex: mex4m mex4o
ifneq ($(shell which matlab), )
mex4m: mexSLOAD.$(MEX_EXT) mexSOPEN.$(MEX_EXT) mexSSAVE.$(MEX_EXT)
mexSLOAD: mexSLOAD.$(MEX_EXT) 
mexSOPEN: mexSOPEN.$(MEX_EXT)
%.$(MEX_EXT): %.cpp ../libbiosig.$(LIBEXT) Makefile
	$(MEX) $(MEX_OPTION) $(DEFINES) $< $(LFLAGS) $(LIBS)
	-$(COPY) $@ ../../biosig/t200_FileAccess/
mexSOPEN.$(MEX_EXT): mexSLOAD.cpp ../libbiosig.$(LIBEXT) Makefile
	$(MEX) $(MEX_OPTION) -DmexSOPEN $(DEFINES) mexSLOAD.cpp $(LFLAGS) $(LIBS) -output mexSOPEN
	-$(COPY) mexSOPEN.$(MEX_EXT) ../../biosig/t200_FileAccess/
endif



### MEX-files for Octave
mex4o:  mexSLOAD.mex mexSOPEN.mex mexSSAVE.mex
%.mex:  %.cpp ../libbiosig.$(LIBEXT) Makefile
	$(OCT)  $(DEFINES) -v -g --mex $< $(LFLAGS) $(LIBS)
	-$(COPY) $@ ../../biosig/t200_FileAccess/
mexSOPEN.mex:  mexSLOAD.cpp ../libbiosig.$(LIBEXT) Makefile
	$(OCT) -D=mexSOPEN $(DEFINES) -v -g --mex mexSLOAD.cpp $(LFLAGS) $(LIBS) -o mexSOPEN.mex
	-$(COPY) mexSOPEN.mex ../../biosig/t200_FileAccess/
#physicalunits.mex:  physicalunits.cpp libbiosig.$(LIBEXT)
#	$(OCT) -v -g --mex physicalunits.cpp $(LFLAGS) $(LIBS)

oct:  mexSLOAD.oct
mexSLOAD.oct:  mexSLOAD.cpp ../libbiosig.$(LIBEXT) Makefile
	$(OCT)  $(DEFINES) mexSLOAD.cpp $(LFLAGS) $(LIBS)
	$(OCT) -D=mexSOPEN $(DEFINES) mexSLOAD.cpp $(LFLAGS) $(LIBS) -o mexSOPEN.oct
	-$(COPY) mexSOPEN.oct ../../biosig/t200_FileAccess/
	-$(COPY) mexSOPEN.oct ../../biosig/t200_FileAccess/


#########################################################
#	MATLAB/WIN32
#########################################################
%.obj: %.cpp
	$(CROSS)-$(CXX) -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W32MAT_INC) -O2 -DMX_COMPAT_32 $< 
%.obj: %.c
	$(CROSS)-$(CXX) -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W32MAT_INC) -O2 -DMX_COMPAT_32 $< 

mexSOPEN.obj: mexSLOAD.cpp
	$(CROSS)-$(CXX) -c -DMATLAB_MEX_FILE -D=mexSOPEN -x c++ -o $@ -I$(W32MAT_INC) -O2 -DMX_COMPAT_32 $< 

%.mexw32: %.obj ../win32/libbiosig.a
	$(CROSS)-$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< -llibmx -llibmex ../win32/libbiosig.a $(LDLIBS) -lws2_32 


#########################################################
#	MATLAB/WIN64
#########################################################
%.o64: %.cpp
	$(CROSS64)-$(CXX) -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W64MAT_INC) -O2 $< 
%.o64: %.c
	$(CROSS64)-$(CXX) -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W64MAT_INC) -O2 $< 

mexSOPEN.o64: mexSLOAD.cpp
	$(CROSS64)-$(CXX) -c -DMATLAB_MEX_FILE -D=mexSOPEN -x c++ -o $@ -I$(W64MAT_INC) -O2 $< 

%.mexw64: %.o64 ../win64/libbiosig.a
	$(CROSS64)-$(CXX) -shared $(GNUMEX64)/mex.def -o $@ -L$(GNUMEX64) -s $< -llibmx -llibmex ../win64/libbiosig.a  $(LDLIBS) -lws2_32

=== mma/Makefile ===
####### Makefile to compile sload.exe for loading data supported by libbiosig into Mathematica
###
###  $Id$
###  Copyright (C) 2010,2011,2012 Alois Schloegl, IST Austria <alois.schloegl@ist.ac.at>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################


###########################################
# user-defined variables 
########################################### 
##########################################################
## set Mathematica variables
MLINKDIR = /usr/local/Wolfram/gridMathematicaServer/7.0/SystemFiles/Links/MathLink/DeveloperKit
MLINKDIR = /usr/local/Wolfram/Mathematica/8.0/SystemFiles/Links/MathLink/DeveloperKit

ifneq ($(shell which mathematica), )
  MLINKDIR  := $(dir $(shell readlink -f $(shell which mathematica) ) )../SystemFiles/Links/MathLink/DeveloperKit
endif
SYS       = Linux-x86-64# Set this value with the result of evaluating $SystemID
MLLIB     = ML64i3 # ML32i3 # Set this to ML64i3 if using a 64-bit system
#
# Windows
#MLINKDIR  = /usr/local/Wolfram/gridMathematicaServer/7.0/SystemFiles/Links/MathLink/DeveloperKit
SYSwin       = Windows# Set this value with the result of evaluating $SystemID
MLLIBwin     = ml32i3m# Set this to ML64i3 if using a 64-bit system
###########################################

CADDSDIR  = ${MLINKDIR}/${SYS}/CompilerAdditions
INCDIR    = ${CADDSDIR}
LIBDIR    = ${CADDSDIR}

EXTRALIBS = -lm -lpthread -lrt -lstdc++ $(LDLIBS) -L.. -lbiosig# Set these with appropriate libs for your system.

MPREP     = ${CADDSDIR}/mprep

all : sload sload.exe sload.w64.exe
win win32 : sload.exe

../libbiosig.a:
	make -C .. libbiosig.a
../win32/libbiosig.a: 
	make -C .. win32/libbiosig.a
../win64/libbiosig.a: 
	make -C .. win64/libbiosig.a


.c.o :
	${CC} -c -I${INCDIR} $<

sloadtm.c : sload.tm
	${MPREP} $< -o $@

sload : sload.o sloadtm.o ../libbiosig.a
	${CC} sloadtm.o sload.o -L${LIBDIR} -l${MLLIB} ${EXTRALIBS} -o $@


###########################################
#   Win32 - cross-compilation 
###########################################

CCw32        = $(CROSS)-gcc
CADDSDIRwin  = ${MLINKDIR}/${SYSwin}/CompilerAdditions/mldev32
INCDIRwin    = ${CADDSDIRwin}/include
LIBDIRwin    = ${CADDSDIRwin}/lib

EXTRALIBSwin =  ../win32/libbiosig.a -lgdi32 -lm -lpthread -lstdc++ -lws2_32 $(LDLIBS) # Set these with appropriate libs for your system.

MPREPwin     = ${CADDSDIRwin}/bin/mprep.exe

sloadtm.win32.c : sload.tm
	wine ${MPREPwin} $? -o $@

sload.obj : sload.c
	${CCw32} -c -I${INCDIRwin} $< -o $@
sloadtm.obj : sloadtm.win32.c
	${CCw32} -c -I${INCDIRwin} $< -o $@

sload.exe : sload.obj sloadtm.obj ../win32/libbiosig.a
	${CCw32} sload.obj sloadtm.obj -static-libgcc -static-libstdc++ -L${LIBDIRwin} -l${MLLIBwin} ${EXTRALIBSwin} -o $@

###########################################
#   Win64 - cross-compilation 
###########################################

CCw64         = $(CROSS64)-gcc
CADDSDIRwin64 = ${MLINKDIR}/${SYSwin}/CompilerAdditions/mldev64
INCDIRwin64   = ${CADDSDIRwin64}/include
LIBDIRwin64   = ${CADDSDIRwin64}/lib

EXTRALIBSwin64 =  ../win64/libbiosig.a -lgdi32 -lm -lpthread -lstdc++ -lws2_32 $(LDLIBS) # Set these with appropriate libs for your system.

MPREPwin64     = ${CADDSDIRwin64}/bin/mprep.exe

sloadtm.win64.c : sload.tm
	wine ${MPREPwin64} $? -o $@

sload.w64.obj : sload.c
	${CCw64} -c -I${INCDIRwin64} $< -o $@
sloadtm.w64.obj : sloadtm.win64.c
	${CCw64} -c -I${INCDIRwin64} $< -o $@

sload.w64.exe : sload.obj sloadtm.w64.obj ../win64/libbiosig.a
	${CCw64} sload.w64.obj sloadtm.w64.obj -static-libgcc -static-libstdc++ -L${LIBDIRwin64} -l${MLLIBwin64} ${EXTRALIBSwin64} -o $@


	
###########################################
clean:
	-$(RM) *.o
	-$(RM) *.obj
	-$(RM) *tm.c
	-$(RM) sload.exe
	-$(RM) sload

=== perl/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  $Id: Makefile 2526 2010-08-27 21:46:28Z schloegl $
###  Copyright (C) 2010 Alois Schloegl <a.schloegl@ieee.org>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################

# More information on SWIG-Perl interface is available here
# http://www.swig.org/Doc1.3/Perl5.html#Perl5



all:
	swig -c++ -perl biosig.i
	g++ -fPIC -c biosig_wrap.cxx -I/usr/lib/perl/5.10.1/CORE -Dbool=char
	g++ -shared ../libbiosig.so biosig_wrap.o -o biosig.so

clean:
	-rm *.cxx 
	-rm *.o
	-rm *.pm
	-rm *.so

=== php/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  $Id: Makefile 2526 2010-08-27 21:46:28Z schloegl $
###  Copyright (C) 2010 Alois Schloegl <a.schloegl@ieee.org>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################

# More information on SWIG-PHP interface is available here
# http://www.swig.org/Doc1.3/Php.html#Php

all:
	swig -c++ -php biosig.i
	gcc `php-config --includes` -fpic -c biosig_wrap.cpp
	gcc -shared biosig_wrap.o -o php_biosig.so

clean:
	-rm *.h 
	-rm *.o 
	-rm *.cpp 
	-rm *.php 
	-rm *.so

=== python/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  $Id: Makefile,v 1.72 2009/03/03 11:46:57 schloegl Exp $
###  Copyright (C) 2006,2007,2008,2009,2012 Alois Schloegl <a.schloegl@ieee.org>
###  This file is part of the "BioSig for C/C++" repository 
###  (biosig4c++) at http://biosig.sf.net/ 
###
##############################################################


all, biosig4python:
	make -C .. biosig4python

=== ruby/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  $Id: Makefile 2526 2010-08-27 21:46:28Z schloegl $
###  Copyright (C) 2010 Alois Schloegl <a.schloegl@ieee.org>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################

# More information on SWIG-Ruby interface is available here
# http://www.swig.org/Doc1.3/Ruby.html#Ruby


### INC must be the directory containing ruby.h
INC 	= /usr/lib/ruby/1.8/x86_64-linux/

all:
	swig -c++ -ruby biosig.i
	g++ -fPIC -c biosig_wrap.cxx -I$(INC) 
	g++ -fPIC -shared biosig_wrap.o ../libbiosig.so -o biosig.so
	

clean: 
	-rm *.o
	-rm *.so
	-rm *.c*

=== t240/Makefile ===
ASN_MODULE_SOURCES=	\
	Address.c	\
	MetricMeasure.c	\
	UnitCode.c	\
	HealthCareProviderId.c	\
	INT-U64.c	\
	INT-I64.c	\
	INT-U32.c	\
	INT-I32.c	\
	INT-U16.c	\
	INT-I16.c	\
	INT-U8.c	\
	INT-I8.c	\
	BITS-32.c	\
	BITS-16.c	\
	BITS-8.c	\
	FEFString.c	\
	FEFFloat.c	\
	Fraction.c	\
	AbsoluteRange.c	\
	Handle.c	\
	HandleRef.c	\
	DeviceCode.c	\
	UnitsOfMeasurementCode.c	\
	MetricsCode.c	\
	BodySiteCode.c	\
	AlertCode.c	\
	ExtNomenclatureCode.c	\
	ParameterGroupCode.c	\
	PrivateCode.c	\
	Placeholder.c	\
	ManufacturerID.c	\
	AbsoluteTime.c	\
	RelativeTime.c	\
	HighResRelativeTime.c	\
	ObservationTime.c	\
	SimpleColour.c	\
	ExtNomenRef.c	\
	PersonNameGroup.c	\
	PersonName.c	\
	OID-Type.c	\
	SessionArchiveSection.c	\
	ArchiveProtection.c	\
	ManufacturerSpecificSection.c	\
	ManufacturerSpecificEncoded.c	\
	ManufacturerSpecificBinary.c	\
	HealthCareProviderSection.c	\
	HealthCareProfessionalSection.c	\
	Authorization.c	\
	PatientDemographicsSection.c	\
	PatMeasure.c	\
	PatientSex.c	\
	PatientType.c	\
	PatientRace.c	\
	SessionTestSection.c	\
	MedicalDeviceSystemSection.c	\
	SystemModel.c	\
	SystemSpecEntry.c	\
	ProdSpecEntryType.c	\
	ProdSpecEntry.c	\
	ApplicationArea.c	\
	PowerStatus.c	\
	LineFrequency.c	\
	MedicalDeviceComponents.c	\
	VirtualMedicalDeviceSection.c	\
	MsmtPrinciple.c	\
	ChannelDescriptionSection.c	\
	ChannelStatus.c	\
	MultimediaSection.c	\
	Comments.c	\
	ContentOrReference.c	\
	SessionPhaseSection.c	\
	DescriptiveDataSection.c	\
	MetricDescriptiveDataSection.c	\
	MetricStatus.c	\
	MetricCategory.c	\
	MetricCalEntry.c	\
	MetricCalType.c	\
	MetricCalState.c	\
	MeasurementStatus.c	\
	SampleArrayDescriptiveDataSection.c	\
	SaSpec.c	\
	StorageDataType.c	\
	SaFlags.c	\
	ScaleRangeSpec.c	\
	SaFilterEntry.c	\
	FilterType.c	\
	SaGridEntry.c	\
	SaCalData.c	\
	SaCalDataType.c	\
	SaSignalFrequency.c	\
	RealTimeSampleArrayDescriptiveDataSection.c	\
	TimeSampleArrayDescriptiveDataSection.c	\
	DistributionSampleArrayDescriptiveDataSection.c	\
	DsaRangeSpec.c	\
	NumericDescriptiveDataSection.c	\
	EnumerationDescriptiveDataSection.c	\
	MeasuredDataSection.c	\
	SampleArrayMeasuredDataSection.c	\
	SampleArrayMeasuredDataBlock.c	\
	RealTimeSampleArrayMeasuredDataSection.c	\
	TimeSampleArrayMeasuredDataSection.c	\
	MarkerEntryRelTim.c	\
	DistributionSampleArrayMeasuredDataSection.c	\
	NumericMeasuredDataSection.c	\
	ChoiceOfNuObsValue.c	\
	NuObsValue.c	\
	DispResolution.c	\
	EnumerationMeasuredDataSection.c	\
	ChoiceOfEnumObsValue.c	\
	EnumObsValue.c	\
	EnumVal.c	\
	EnumObject.c	\
	EnumRecordMetric.c	\
	EnumRecordOO.c	\
	ChoiceOfEnumTimeStamp.c	\
	AlertSection.c	\
	AlertCondition.c	\
	AlertControls.c	\
	AlertFlags.c	\
	AlertType.c	\
	LimitSpecEntry.c	\
	CurLimAlStat.c	\
	DynamicAttributeChangeSection.c	\
	SessionNotesSection.c

ASN_MODULE_HEADERS=	\
	Address.h	\
	MetricMeasure.h	\
	UnitCode.h	\
	HealthCareProviderId.h	\
	INT-U64.h	\
	INT-I64.h	\
	INT-U32.h	\
	INT-I32.h	\
	INT-U16.h	\
	INT-I16.h	\
	INT-U8.h	\
	INT-I8.h	\
	BITS-32.h	\
	BITS-16.h	\
	BITS-8.h	\
	FEFString.h	\
	FEFFloat.h	\
	Fraction.h	\
	AbsoluteRange.h	\
	Handle.h	\
	HandleRef.h	\
	DeviceCode.h	\
	UnitsOfMeasurementCode.h	\
	MetricsCode.h	\
	BodySiteCode.h	\
	AlertCode.h	\
	ExtNomenclatureCode.h	\
	ParameterGroupCode.h	\
	PrivateCode.h	\
	Placeholder.h	\
	ManufacturerID.h	\
	AbsoluteTime.h	\
	RelativeTime.h	\
	HighResRelativeTime.h	\
	ObservationTime.h	\
	SimpleColour.h	\
	ExtNomenRef.h	\
	PersonNameGroup.h	\
	PersonName.h	\
	OID-Type.h	\
	SessionArchiveSection.h	\
	ArchiveProtection.h	\
	ManufacturerSpecificSection.h	\
	ManufacturerSpecificEncoded.h	\
	ManufacturerSpecificBinary.h	\
	HealthCareProviderSection.h	\
	HealthCareProfessionalSection.h	\
	Authorization.h	\
	PatientDemographicsSection.h	\
	PatMeasure.h	\
	PatientSex.h	\
	PatientType.h	\
	PatientRace.h	\
	SessionTestSection.h	\
	MedicalDeviceSystemSection.h	\
	SystemModel.h	\
	SystemSpecEntry.h	\
	ProdSpecEntryType.h	\
	ProdSpecEntry.h	\
	ApplicationArea.h	\
	PowerStatus.h	\
	LineFrequency.h	\
	MedicalDeviceComponents.h	\
	VirtualMedicalDeviceSection.h	\
	MsmtPrinciple.h	\
	ChannelDescriptionSection.h	\
	ChannelStatus.h	\
	MultimediaSection.h	\
	Comments.h	\
	ContentOrReference.h	\
	SessionPhaseSection.h	\
	DescriptiveDataSection.h	\
	MetricDescriptiveDataSection.h	\
	MetricStatus.h	\
	MetricCategory.h	\
	MetricCalEntry.h	\
	MetricCalType.h	\
	MetricCalState.h	\
	MeasurementStatus.h	\
	SampleArrayDescriptiveDataSection.h	\
	SaSpec.h	\
	StorageDataType.h	\
	SaFlags.h	\
	ScaleRangeSpec.h	\
	SaFilterEntry.h	\
	FilterType.h	\
	SaGridEntry.h	\
	SaCalData.h	\
	SaCalDataType.h	\
	SaSignalFrequency.h	\
	RealTimeSampleArrayDescriptiveDataSection.h	\
	TimeSampleArrayDescriptiveDataSection.h	\
	DistributionSampleArrayDescriptiveDataSection.h	\
	DsaRangeSpec.h	\
	NumericDescriptiveDataSection.h	\
	EnumerationDescriptiveDataSection.h	\
	MeasuredDataSection.h	\
	SampleArrayMeasuredDataSection.h	\
	SampleArrayMeasuredDataBlock.h	\
	RealTimeSampleArrayMeasuredDataSection.h	\
	TimeSampleArrayMeasuredDataSection.h	\
	MarkerEntryRelTim.h	\
	DistributionSampleArrayMeasuredDataSection.h	\
	NumericMeasuredDataSection.h	\
	ChoiceOfNuObsValue.h	\
	NuObsValue.h	\
	DispResolution.h	\
	EnumerationMeasuredDataSection.h	\
	ChoiceOfEnumObsValue.h	\
	EnumObsValue.h	\
	EnumVal.h	\
	EnumObject.h	\
	EnumRecordMetric.h	\
	EnumRecordOO.h	\
	ChoiceOfEnumTimeStamp.h	\
	AlertSection.h	\
	AlertCondition.h	\
	AlertControls.h	\
	AlertFlags.h	\
	AlertType.h	\
	LimitSpecEntry.h	\
	CurLimAlStat.h	\
	DynamicAttributeChangeSection.h	\
	SessionNotesSection.h

ASN_MODULE_HEADERS+=ANY.h
ASN_MODULE_SOURCES+=ANY.c
ASN_MODULE_HEADERS+=UTF8String.h
ASN_MODULE_HEADERS+=INTEGER.h
ASN_MODULE_HEADERS+=NativeEnumerated.h
ASN_MODULE_HEADERS+=GeneralizedTime.h
ASN_MODULE_SOURCES+=GeneralizedTime.c
ASN_MODULE_SOURCES+=INTEGER.c
ASN_MODULE_SOURCES+=NativeEnumerated.c
ASN_MODULE_HEADERS+=NativeInteger.h
ASN_MODULE_SOURCES+=NativeInteger.c
ASN_MODULE_HEADERS+=REAL.h
ASN_MODULE_HEADERS+=OBJECT_IDENTIFIER.h
ASN_MODULE_SOURCES+=OBJECT_IDENTIFIER.c
ASN_MODULE_SOURCES+=REAL.c
ASN_MODULE_SOURCES+=UTF8String.c
ASN_MODULE_HEADERS+=asn_SEQUENCE_OF.h
ASN_MODULE_SOURCES+=asn_SEQUENCE_OF.c
ASN_MODULE_HEADERS+=asn_SET_OF.h
ASN_MODULE_SOURCES+=asn_SET_OF.c
ASN_MODULE_HEADERS+=constr_CHOICE.h
ASN_MODULE_SOURCES+=constr_CHOICE.c
ASN_MODULE_HEADERS+=constr_SEQUENCE.h
ASN_MODULE_SOURCES+=constr_SEQUENCE.c
ASN_MODULE_HEADERS+=constr_SEQUENCE_OF.h
ASN_MODULE_SOURCES+=constr_SEQUENCE_OF.c
ASN_MODULE_HEADERS+=constr_SET_OF.h
ASN_MODULE_SOURCES+=constr_SET_OF.c
ASN_MODULE_HEADERS+=asn_application.h
ASN_MODULE_HEADERS+=asn_system.h
ASN_MODULE_HEADERS+=asn_codecs.h
ASN_MODULE_HEADERS+=asn_internal.h
ASN_MODULE_HEADERS+=OCTET_STRING.h
ASN_MODULE_SOURCES+=OCTET_STRING.c
ASN_MODULE_HEADERS+=BIT_STRING.h
ASN_MODULE_SOURCES+=BIT_STRING.c
ASN_MODULE_SOURCES+=asn_codecs_prim.c
ASN_MODULE_HEADERS+=asn_codecs_prim.h
ASN_MODULE_HEADERS+=ber_tlv_length.h
ASN_MODULE_SOURCES+=ber_tlv_length.c
ASN_MODULE_HEADERS+=ber_tlv_tag.h
ASN_MODULE_SOURCES+=ber_tlv_tag.c
ASN_MODULE_HEADERS+=ber_decoder.h
ASN_MODULE_SOURCES+=ber_decoder.c
ASN_MODULE_HEADERS+=constr_TYPE.h
ASN_MODULE_SOURCES+=constr_TYPE.c
ASN_MODULE_HEADERS+=constraints.h
ASN_MODULE_SOURCES+=constraints.c
ASN_MODULE_HEADERS+=der_encoder.h
ASN_MODULE_SOURCES+=der_encoder.c
ASN_MODULE_HEADERS+=xer_support.h
ASN_MODULE_SOURCES+=xer_support.c
ASN_MODULE_HEADERS+=xer_decoder.h
ASN_MODULE_SOURCES+=xer_decoder.c
ASN_MODULE_HEADERS+=xer_encoder.h
ASN_MODULE_SOURCES+=xer_encoder.c
ASN_MODULE_HEADERS+=per_opentype.h
ASN_MODULE_SOURCES+=per_opentype.c
ASN_MODULE_HEADERS+=per_support.h
ASN_MODULE_SOURCES+=per_support.c
ASN_MODULE_HEADERS+=per_decoder.h
ASN_MODULE_SOURCES+=per_decoder.c
ASN_MODULE_HEADERS+=per_encoder.h
ASN_MODULE_SOURCES+=per_encoder.c
#ASN_CONVERTER_SOURCES+=converter-sample.c



lib_LTLIBRARIES=libsomething.la
libsomething_la_SOURCES=$(ASN_MODULE_SOURCES) $(ASN_MODULE_HEADERS)

# This file may be used as an input for make(3)
# Remove the lines below to convert it into a pure .am file
WIN32  = ../win32/libcnsfef.a ../win32/libcnsfef.dll
WIN64  = ../win64/libcnsfef.a ../win64/libcnsfef.dll
TARGET = libcnsfef.a $(WIN32)
CFLAGS += -pipe -fPIC -Wall -O2 -Wextra  -I.
OBJS=${ASN_MODULE_SOURCES:.c=.o} ${ASN_CONVERTER_SOURCES:.c=.o}
WINOBJS=${ASN_MODULE_SOURCES:.c=.obj} ${ASN_CONVERTER_SOURCES:.c=.obj}
W64OBJS=${ASN_MODULE_SOURCES:.c=.o64} ${ASN_CONVERTER_SOURCES:.c=.o64}

CC        = gcc
AR        = ar crs
MinGWCC   = $(CROSS)-gcc 
MinGW64CC = $(CROSS64)-gcc 

all: $(TARGET)

#$(TARGET): ${OBJS}
#	$(CC) $(CFLAGS) -o $(TARGET) ${OBJS} $(LDFLAGS) $(LIBS)

libcnsfef.a: $(OBJS) 
	$(AR) libcnsfef.a $(OBJS) 

../win32/libcnsfef.a: $(WINOBJS) 
	$(CROSS)-$(AR) ../win32/libcnsfef.a $(WINOBJS) 

../win64/libcnsfef.a: $(W64OBJS) 
	$(CROSS64)-$(AR) ../win64/libcnsfef.a $(W64OBJS) 

../win32/libcnsfef.dll: $(WINOBJS)
	$(MinGWCC) -shared -fPIC  $(WINOBJS)  -Wl,--output-def,../win32/libcnsfef.def,--out-implib,../win32/libcnsfef.dll

../win64/libcnsfef.dll: $(WINOBJS)
	$(MinGW64CC) -shared -fPIC  $(W64OBJS)  -Wl,--output-def,../win64/libcnsfef.def,--out-implib,../win64/libcnsfef.dll


.SUFFIXES:
.SUFFIXES: .c .o

%.obj: %.c
	$(CROSS)-$(CC) $(CFLAGS) -o $@ -c $<
%.o64: %.c
	$(CROSS64)-$(CC) $(CFLAGS) -o $@ -c $<

.c.o:
	$(CC) $(CFLAGS) -o $@ -c $<

clean:
#	rm -f $(ASN_MODULE_HEADERS)
#	rm -f $(ASN_MODULE_SOURCES)
	rm -f $(TARGET)
	rm -f $(OBJS)
	rm -f $(WINOBJS)
	rm -f $(W64OBJS)
	rm -f Makefile.am.sample libfef.a 

regen: regenerate-from-asn1-source 

regenerate-from-asn1-source:
	asn1c -fcompound-names ../annexb-snacc-122001.asn1 
	rm -f converter-sample.c Makefile.am.sample libfef.a

=== debian/changelog ===
biosig4c++ (1.3.0-2.1build1) xenial; urgency=medium

  * No-change rebuild against suitesparse 1:4.4.5-2

 -- Graham Inggs <graham@nerve.org.za>  Tue, 01 Dec 2015 11:41:43 +0200

biosig4c++ (1.3.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Port from python-support to dh_python2. (Closes: #785953)

 -- Stefano Rivera <stefanor@debian.org>  Wed, 19 Aug 2015 20:32:12 +0200

biosig4c++ (1.3.0-2) unstable; urgency=low

  * Do not build biosig_{client,server} which are still experimental and
    actually were not shipped within any package anyway (as a side-effect
    Closes: #675582)

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 03 Jun 2012 22:18:19 -0400

biosig4c++ (1.3.0-1) unstable; urgency=low

  * Fresh upstream release
    - libbiosig now SOVERSION 1, thus libbiosig1{,-dbg} to replace
      libbiosig0
  * debian/copyright: updated for DEP5
  * debian/patches:
    - added up_memcpy_str_cast (sent upstream)
    - removed up_for_loop_initial (upstreamed)
    - removed up_*oct* (no hardcoded octave version information in
      upstream Makefile any longer), deb_link_dynamically_python
    - removed deb_link_dynamically in favor of specifying LIBEXT=so to
      calls to make
    - removed deb_use_borrowed_eventcodes: now debian/upstream-extern
      provides needed extra external files (from biosig) and gets symlinked
      as extern at build time
    - refreshed deb_no_mex_copy_upstairs,deb_no_locals
  * upstream-files/eventcodes.txt -- refreshed from online
  * debian/control:
    - new build-depends: gawk, libxml2-dev
    - boosted policy to 3.9.3 -- no further changes

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 24 May 2012 09:22:13 -0400

biosig4c++ (0.96.3+svn2677-4) UNRELEASED; urgency=low

  * debian/upstream: Authors need to be separated by ' and ' rather than
    by ','

 -- Andreas Tille <tille@debian.org>  Wed, 09 May 2012 09:48:22 +0200

biosig4c++ (0.96.3+svn2677-3) unstable; urgency=low

  * ACK the .1 NMU (Thank you Miguel)
    - debian/rules: call dh_numpy only if available
  * Use unversioned mkoctfile (Closes: #665051).
    Thanks Lucas Nussbaum for the report and Nicolas Bourdaud for the patch.
  * debian/rules, debian/control
    - fixed typo in debian/control resulting in octave:Depends
    - adjusted conditional use of octave-depends across systems (should
      generate octave:Depends subst for recent systems lacking
      octave-depends)
  * debian/patches: refreshed

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 11 Apr 2012 12:36:54 -0400

biosig4c++ (0.96.3+svn2677-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "missing dependency on python-numpy" by adding dh_numpy under
    override_dh_auto_install (Closes: #641790)

 -- Miguel de Val Borro <miguel.deval@gmail.com>  Fri, 02 Dec 2011 20:02:39 +0100

=== debian/control ===
Source: biosig4c++
Priority: extra
Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), dh-python,
               gawk, libxml2-dev,
               python-dev, swig, python-numpy,
               zlib1g-dev, libsuitesparse-dev,
               octave-pkg-dev (>= 0.5.7),
Standards-Version: 3.9.3
Section: science
Homepage: http://biosig.sf.net/
Vcs-Git: git://git.debian.org/pkg-exppsy/biosig4c--.git
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/biosig4c--.git;a=summary

Package: libbiosig1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: I/O library for biomedical data - dynamic library
 BioSig is a library for accessing files in several biomedical data formats
 (including EDF, BDF, GDF, BrainVision, BCI2000, CFWB, HL7aECG,
 SCP_ECG (EN1064), MFER, ACQ, CNT(Neuroscan), DEMG, EGI, EEG1100,
 FAMOS, SigmaPLpro, TMS32).  The complete list of supported file
 formats is available at http://pub.ist.ac.at/~schloegl/biosig/TESTED .
 .
 This package provides dynamic library.

Package: libbiosig1-dbg
Section: debug
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libbiosig1 (= ${binary:Version})
Description: I/O library for biomedical data - debug symbols
 BioSig is a library for accessing files in several biomedical data formats
 (including EDF, BDF, GDF, BrainVision, BCI2000, CFWB, HL7aECG,
 SCP_ECG (EN1064), MFER, ACQ, CNT(Neuroscan), DEMG, EGI, EEG1100,
 FAMOS, SigmaPLpro, TMS32).  The complete list of supported file
 formats is available at http://pub.ist.ac.at/~schloegl/biosig/TESTED .
 .
 This package provides debug symbols.

Package: libbiosig-dev
Section: libdevel
Architecture: any
Depends: libbiosig1 (= ${binary:Version}), ${misc:Depends}
Description: I/O library for biomedical data - development files
 BioSig is a library for accessing files in several biomedical data formats
 (including EDF, BDF, GDF, BrainVision, BCI2000, CFWB, HL7aECG,
 SCP_ECG (EN1064), MFER, ACQ, CNT(Neuroscan), DEMG, EGI, EEG1100,
 FAMOS, SigmaPLpro, TMS32).  The complete list of supported file
 formats is available at http://pub.ist.ac.at/~schloegl/biosig/TESTED .
 .
 This package provides header files and static library.

Package: biosig-tools
Section: science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: format conversion tools for biomedical data formats
 Based on BioSig library, this package provides command line
 tools, such as
 .
  - save2gdf: converter between different file formats, including but
    not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF, BDF,
    CWFB.  save2gdf can be also used to upload or retrieve data from a
    bscs server.

Package: python-biosig
Section: python
Architecture: any
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Python bindings for BioSig library
 This package provides Python bindings for BioSig library.  Primary
 goal -- I/O interface to variety of biomedical file formats, including
 but not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF.

Package: octave-biosig
Architecture: any
Depends: ${octave:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Octave bindings for BioSig library
 This package provides Octave bindings for BioSig library.  Primary
 goal -- I/O interface to variety of biomedical file formats, including
 but not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

MAKEOPTS=LIBEXT=so

%:
	dh  $@ --with python2

override_dh_auto_configure:
	dh_auto_configure
	: # Use our copies
	ln -s debian/upstream-extern extern

override_dh_auto_build:
	: # Build everything upstream builds by default
	make $(MAKEOPTS)
	: # Assure additional interesting to us pieces are built
	make $(MAKEOPTS) libbiosig.so mex4o biosig4python 
	#make libbiosig.a save2gdf save2aecg save2scp pdp2gdf \
	#	 biosig_client biosig_server
	# Later: libbiosig.so -- fails, no SONAME etc,
	#         mex4o -- there are some copying etc
	# Later: Python -- depends on obsolete Numeric
	#        biosig4python 
	#  to build for multiple Python's would need to loop
	#  between versions with smth like make python -B PYTHONVER=2.6

override_dh_auto_test:
	: I: skip testing for now -- relies on download of test data

# Manual crafting of installing Octave and Python bindings
# TODO: proper
PYTHON=$(shell pyversions -d)
PYDIR=$(shell /bin/ls -d /usr/lib/$(PYTHON)/*-packages)

OCTDIR=$(shell octave-config --oct-site-dir)

override_dh_auto_install:
	dh_auto_install

	: I: install Python binding for current Python verion TODO: all
	mkdir -p debian/python-biosig$(PYDIR)
	install -m 0644 python/biosig.py python/_biosig.so debian/python-biosig$(PYDIR)

	: I: install Octave bindings
	mkdir -p debian/octave-biosig$(OCTDIR)
	: # install with executable flag so dh_{strip,...} tools could catch it to operate
	install mex/mexS*.mex debian/octave-biosig$(OCTDIR)

	[ -x /usr/bin/dh_numpy ] && dh_numpy || :


override_dh_makeshlibs:
	dh_makeshlibs
	: # Provide Octave:Depends
	[ -e /usr/bin/octave-depends ] \
	&& octave-depends \
	|| echo 'octave:Depends=octave (>= 3.4.3-1~)' >> debian/octave-biosig.substvars


override_dh_strip:
	dh_strip --dbg-package=libbiosig1-dbg

# Tune up permission for .mex files this late in the chain
# Silly dh_strip, dh_shlibdeps do not process those since extension
# is "unknown" to them and they are not executable
override_dh_gencontrol:
	chmod a-x debian/octave-biosig$(OCTDIR)/*.mex
	dh_gencontrol

override_dh_auto_clean:
	dh_auto_clean
	make $(MAKEOPTS) clean					# distclean invoked by auto isn't enough
	-rm extern

=== debian/watch ===
version=3
http://sf.net/biosig/biosig4c\+\+-(.*)\.zip
